package com.ann.demo.service.impl;

import com.ann.demo.entity.filing.ExamApplyDto;
import com.ann.demo.repository.ArchiveDetailRepository;
import com.ann.demo.service.ArchiveDetailService;
import com.ann.demo.util.MapObjUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.File;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @Author: LeiJiaXin
 * @Date: 2019/7/12 9:12
 */
@Service
public class ArchiveDetailServiceImpl implements ArchiveDetailService {

    @Autowired
    ArchiveDetailRepository archiveDetailRepository;


    @Override
    public String getTypeNotExits(List<String> type, String masterId) {
        return archiveDetailRepository.getTypeNotExits(type, masterId);
    }

    @Override
    public String getTypeToVoid(String masterId) {
        return archiveDetailRepository.getTypeToVoid(masterId);
    }

    @Override
    public String getCheckReportNotExits(List<String> type, String masterId) {
        return archiveDetailRepository.getCheckReportNotExits(type, masterId);
    }

    @Override
    public String getInspectionReportNotExits1(List<String> type, String masterId) {
        String result = null;
        // 1、查出所有的检验申请单
        List<Map<Object, Object>> examAllTempList = archiveDetailRepository.getAllInspectionApply(type, masterId);
        if (examAllTempList == null || examAllTempList.isEmpty()) {
            return null;
        }
        //转成对应的集合
        List<ExamApplyDto> examAllList = new ArrayList<ExamApplyDto>();
        for (Map<Object, Object> map : examAllTempList) {
            ExamApplyDto examApplyDto = MapObjUtil.map2Object(map, ExamApplyDto.class);
            examAllList.add(examApplyDto);
        }
        // 2、查出所有的detail
        List<String> applyIdTempList = archiveDetailRepository.getInspectionApply(type, masterId);
        // 3、进行匹配
        List<ExamApplyDto> resultList = new ArrayList<ExamApplyDto>(examAllList);
        for (ExamApplyDto examApplyDto : examAllList) {
            for (String applyId : applyIdTempList) {
                if (!applyId.isEmpty()) {
                    Pattern pattern = Pattern.compile(examApplyDto.getApplyId());
                    Matcher matcher = pattern.matcher(applyId);
                    if (matcher.find()) {
                        resultList.remove(examApplyDto);
                    }
                }
            }
        }
        StringBuffer sb = new StringBuffer();
        for (ExamApplyDto examApplyDto :
                resultList) {
            String authorReportTime = examApplyDto.getAuthorReportTime();
            if (authorReportTime != null && authorReportTime.lastIndexOf(".") != -1) {
                authorReportTime = authorReportTime.substring(0, authorReportTime.lastIndexOf("."));
            }
            sb.append("缺失" + examApplyDto.getName() + "(" + authorReportTime + ")，");
        }
        if (sb.length() > 0) {
            result = sb.substring(0, sb.length() - 1);
        }
        return result;
    }

    @Override
    public String getBeHospitalized(String masterid, String assortId) {
        return archiveDetailRepository.getResultByMasterIDAndAssortIDAndFlag(masterid, assortId, "0");
    }

    @Override
    public Integer countDetail(String masterId, String s) {
        return archiveDetailRepository.countDetail(masterId, s, "0");
    }

//    @Override
//    public String getInspectionReportNotExits(List<String> type,String masterId) {
//        return archiveDetailRepository.getInspectionReportNotExits( type,masterId);
//    }

    @Override
    public String getCheckReportNotExits1(List<String> types, String masterId) {
        return archiveDetailRepository.getCheckReportNotExits1(types, masterId);
    }

    @Override
    public Integer countFirstNursingRecord(String masterId, String s) {
        return archiveDetailRepository.countFirstNursingRecord(masterId, s, "0");
    }

    @Override
    public int getDicomNum(String masterId) {
        return archiveDetailRepository.getDicomNum(masterId);
    }
}


//        List<Map<Object, Object>> examAndDetailTempList = archiveDetailRepository.getInspectionApply(type, masterId);
//        if (examAndDetailTempList == null || examAndDetailTempList.isEmpty()){
//            return null;
//        }
//        //转换成对应的集合
//        List<ExamApplyDto> examAndDetailList = new ArrayList<ExamApplyDto>();
//        for (Map<Object, Object> map: examAndDetailTempList){
//            ExamApplyDto  examApplyDto = MapObjUtil.map2Object(map,ExamApplyDto.class);
//            examAndDetailList.add(examApplyDto);
//        }
//
//
//
//
//        // 3、取出两个集合的交集
//        for (ExamApplyDto examApplyDto : examAndDetailList) {
//            if (examAllList.contains(examApplyDto)) {
//                examAllList.remove(examApplyDto);
//            }
//        }
